/*
 * Turnstiles.java
 *
 * Modified on 3. 12. 2008
 */

package cz.muni.fi.pb162.traffic.turnstiles;

import cz.muni.fi.pb162.traffic.network.Stop;

/**
 * Turnstiles on all stops.
 * @author misko
 */
public class Turnstiles {
    
   
    /** Creates a new instance of Turnstiles */
    private Turnstiles() {
    }
    
    /**
     * Gives the turnstiles. Implements the singleton design pattern -- only one turnstiles set is to work with
     * @return turnstiles
     */
    public static Turnstiles getInstance() {
        return null;
    }
    
    /**
     * Manipulates with turnstile specified by it's serial number (should be unique).
     * If there is the specified turnstile in the system, it is moved to new location (station). Otherwise a new turnstile is added.
     * @param serialNumber unique serial number of the turnstile
     * @param station station where the turnicle is installed
     * @throws NullPointerException if serial number is null
     * @throws IllegalArgumentException if serial number is an empty string
     * @throws NullPointerException if station is null
     *
     */
    public void addOrMoveTurnstile(String serialNumber, Stop station) {
    }
    
    /**
     * Removes the turnstile specified by it's serial number (should be unique).
     * @param serialNumber turnstile to remove
     * @throws NullPointerException if serial number is null
     * @throws IllegalArgumentException if serial number is an empty string
     * @throws IllegalArgumentException if turnstile is not found
     */
    public void removeTurnstile(String serialNumber) {
    }
    
    /**
     * Finds turnstile specified by it's serial number
     * @param serialNumber serial number of the turnstile
     * @return found turnstile
     * @throws IllegalArgumentException if serial number is not known
     */
    Turnstile findTurnstile(String serialNumber) {
        return null;
    }
    
    /**
     * Reinitialisation -- discarts all tickets
     * @deprecated only for test purposes
     */
    public void reset() {
    }
    
    /**
     * Gives the basic information about the turnstiles
     * @return text information about all turnstiles
     */
    public String toString() {
        return null;
    }
    
    
    
    
    
    
}
