/*
 * NetworkTest.java
 * JUnit based test
 *
 * Created on Pondelok, 2007, november 19, 13:49
 */
package cz.muni.fi.pb162.traffic.network;

import cz.muni.fi.pb162.traffic.common.World;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import junit.framework.TestCase;

/**
 *
 * @author misko
 */
public class NetworkTest extends TestCase {

    World world = new World();

    public NetworkTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        world.createWorld();
    }

    protected void tearDown() throws Exception {
        world.destroyWorld();
    }
    

    /**
     * Test of distance method, of class traffic.Network.
     */
    public void testNextStops() {


        Stop l = new Stop("l");

        Set<Stop> nextK = new HashSet<Stop>();
        nextK.add(l);
        Set<Stop> nextL = new HashSet<Stop>();
        Stop k = new Stop("k");
        Stop m = new Stop("m");
        Stop r = new Stop("r");
        nextL.add(k);
        nextL.add(m);
        nextL.add(r);

        Set<Stop> nextC = new HashSet<Stop>();
        Stop x = new Stop("x");
        Stop n = new Stop("n");
        Stop d = new Stop("d");
        Stop b = new Stop("b");
        nextC.add(x);
        nextC.add(d);
        nextC.add(n);
        nextC.add(b);
        nextC.add(m);

        
        Stop a = new Stop("a");
        Stop c = new Stop("c");
        Stop e = new Stop("e");
        Stop f = new Stop("f");
                
        Stop o = new Stop("o");

        Stop p = new Stop("p");
        Stop q = new Stop("q");
        Stop s = new Stop("s");
        Stop t = new Stop("t");
        Stop u = new Stop("u");
        Stop v = new Stop("v");

        Stop y = new Stop("y");
        Stop z = new Stop("z");


        assertEquals(nextK, world.getNetwork().getNextStops(k));
        assertEquals(nextL, world.getNetwork().getNextStops(l));
        assertEquals(nextC, world.getNetwork().getNextStops(c));

    }
    /**
     * Test of distance method, of class traffic.Network.
     */
    public void testDistance() {


        Stop a = new Stop("a");
        Stop b = new Stop("b");
        Stop c = new Stop("c");
        Stop d = new Stop("d");
        Stop e = new Stop("e");
        Stop f = new Stop("f");

        Stop k = new Stop("k");
        Stop l = new Stop("l");
        Stop m = new Stop("m");
        Stop n = new Stop("n");
        Stop o = new Stop("o");

        Stop p = new Stop("p");
        Stop q = new Stop("q");
        Stop r = new Stop("r");
        Stop s = new Stop("s");
        Stop t = new Stop("t");
        Stop u = new Stop("u");
        Stop v = new Stop("v");

        Stop x = new Stop("x");
        Stop y = new Stop("y");
        Stop z = new Stop("z");


        assertEquals(1, world.getNetwork().distance(k, l));
        assertEquals(2, world.getNetwork().distance(k, m));
        assertEquals(1, world.getNetwork().distance(p, q));
        assertEquals(5, world.getNetwork().distance(q, p));
        assertEquals(2, world.getNetwork().distance(c, y));
        assertEquals(3, world.getNetwork().distance(c, s));
        assertEquals(4, world.getNetwork().distance(c, t));
        assertEquals(6, world.getNetwork().distance(f, k));
        assertEquals(2, world.getNetwork().distance(c, o));
        assertEquals(7, world.getNetwork().distance(s, r));

    }

    /**
     * Test time of distance method, of class traffic.Network.
     */
    public void testDistanceTime() {


        Stop a = new Stop("a");
        Stop b = new Stop("b");
        Stop c = new Stop("c");
        Stop d = new Stop("d");
        Stop e = new Stop("e");
        Stop f = new Stop("f");

        Stop k = new Stop("k");
        Stop l = new Stop("l");
        Stop m = new Stop("m");
        Stop n = new Stop("n");
        Stop o = new Stop("o");

        Stop p = new Stop("p");
        Stop q = new Stop("q");
        Stop r = new Stop("r");
        Stop s = new Stop("s");
        Stop t = new Stop("t");
        Stop u = new Stop("u");
        Stop v = new Stop("v");

        Stop x = new Stop("x");
        Stop y = new Stop("y");
        Stop z = new Stop("z");

        Date start = new Date();
        int itertations = 10000;
        for (int i = 0; i < itertations; i++) {
            world.getNetwork().distance(k, l);
            world.getNetwork().distance(k, m);
            world.getNetwork().distance(p, q);
            world.getNetwork().distance(q, p);
            world.getNetwork().distance(c, y);
            world.getNetwork().distance(c, s);
            world.getNetwork().distance(c, t);
            world.getNetwork().distance(f, k);
            world.getNetwork().distance(c, o);
            world.getNetwork().distance(s, r);
        }
        Date end = new Date();
        long time = end.getTime() - start.getTime();
        double oneIteration = time * 100 / itertations;
        System.out.println(itertations + " iterations take " + time + " ms");
        System.out.println("one path finding takes approximately " + oneIteration + " µs");
    }
}
